uses Dos;
var
  FromF: file;
  ToF  : text;{textfile}
  dd : array[1..10] of string[255];
  info     :string;
  i        : integer;
  j        : longint;
  error    : integer;
  mean     : real;

Procedure stop;
begin
 close(fromf);
 close(tof);
 halt;
end;

function date_conv(inp:string):string;
var  year,month,day:string;
begin
  if inp[4]='A' then month:='10'
  else
  if inp[4]='B' then month:='11'
  else
  if inp[4]='C' then month:='12'
  else
  month:='0'+inp[4]; {01 till 09}
  if ord(inp[5])<58 then day:='0'+inp[5]
  else
  str(ord(inp[5])-55:2,day);  {A: 65-55=10....}
  date_conv:='20'+copy(inp,2,2)+' '+month+' '+day+'.000';
end;

Procedure READVERYBIGASCII;{ 50 MBYTE DOES NOT WORK WITH READLN and also solve problem with missing #13}
{version 2002-12}
var
   buf :array[0..255] of char;
   numread,i  :word;

begin
   info:='';
   BlockRead(FromF,buf, SizeOf(buf),NumRead);
   i:=0;
   repeat
     inc(i);
     info[i]:=buf[i-1];
   until ((i>=255) or (buf[i-1]=#10));
   if buf[i-1]=#10 then info[0]:=char(i-1) {adjust length string}
   else
   begin
     writeln('Error !!!!');
     stop; {no charactor 10 found}
   end;
   if eof(fromf)=false then seek(fromf,filepos(fromf)-sizeof(buf)+length(info)+1);{set pointer good}
end;



begin
  { Open input file }
  if paramcount=0 then
  begin
    writeln('MPCORB.DAT minor planet file to HNSKY asteroid file. Version 1.0, Date: 2002-12-16');
    writeln;
    writeln('Usage: MPC-HNS inputfile.dat');
    writeln('Output will be hns_ast1.ast');
  halt;
  end;
  Assign(FromF,paramstr(1));
 { Record size = 1 }
  filemode:=0;{otherwise reset does not accept files with read only attrib, this to prevent problems}
  reset(fromf,1);
  { Open output file }
  Assign(ToF,'hns_ast1.ast');
  { Record size = 1 }
  Rewrite(ToF);
  j:=0;

  writeln(tof,';Minor planet center orbit database (MPCORB) converted to HNSKY format.');
  writeln(Tof,';');
  writeln(Tof,';New HNSKY format:');
  writeln(Tof,
   ';                     yyyy mm dd.ddd    e        a [ae]     i       ohm         w     [yyyy]             H     G  ');
  writeln(Tof
  ,';--------------------+--------------+--------- +--------+--------+---------+---------+-----+----------+-----+-----');
  writeln(Tof,';');
  writeln(tof,';Original header if any:');
  writeln(tof,';');
  repeat
     READVERYBIGASCII;
     val(copy(info,27,35-27+1) {mean anomaly},mean,error);
     if error=0 then {asteroid data, no comments}
     begin
       dd[1]:=copy(info,167,194-167+1);{name}
       dd[2]:=date_conv(copy(info,21,25-21+1));{epoch}
       dd[3]:=copy(info,71,79-71+1); {e}
       dd[4]:=copy(info,93,103-93+1); {a}
       dd[5]:=copy(info,60,68-60+1); {i}
       dd[6]:=copy(info,49,57-49+1); {ohm}
       dd[7]:=copy(info,38,46-38+1); {w}
       dd[8]:=copy(info,27,35-27+1); {mean anomaly}
       dd[9]:=copy(info,9,13-9+1); {H}
       dd[10]:=copy(info,15,19-15+1); {G}

       writeln(Tof,dd[1],'|',dd[2]{date},'|',dd[3]:10{e},'|',dd[4]:8{a 7},
                      '|',dd[5]:8{i 11},'|',dd[6]:9{ohm},'|',dd[7]:9{w},'|2000|',dd[8]:10,'|',dd[9]:5,{H}'|',dd[10]:5{G},'|A');
     end
     else
     writeln(Tof,';',info);{info text}
     inc(j);
     writeln('Asteroid: ',j);
  until (eof(fromf));
  Close(FromF);
  Close(ToF);
  writeln('Output file is hns_ast1.ast');
end.